#ifndef UTIL_H_
#define UTIL_H_
#include <stdio.h>
#include <stdarg.h>

extern void wios_fail(const char * fmt, ...);

#define WIOS_ERROR(fmt,...) do { wios_fail("ERROR: " fmt, __VA_ARGS__); goto error; } while (0)
#define WIOS_ERROR_S(fmt,...) WIOS_ERROR(fmt, NULL)
#define WIOS_WARN(fmt,...) do { wios_fail("WARN: " fmt, __VA_ARGS__); } while (0)
#define ARRAY_SIZE(arr) ((sizeof(arr))/(sizeof((arr)[0])))
#endif
